/*****************************************************************************
 * Copyright (c) 2021 Christian W. Damus, CEA LIST, and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License 2.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *   Christian W. Damus - Initial API and implementation
 *
 *****************************************************************************/

package org.eclipse.papyrus.toolsmiths.validation.elementtypes.internal.messages;

import org.eclipse.osgi.util.NLS;

/**
 * Externalized strings for the bundle.
 */
public class Messages extends NLS {
	private static final String BUNDLE_NAME = "org.eclipse.papyrus.toolsmiths.validation.elementtypes.internal.messages.messages"; //$NON-NLS-1$
	public static String ApplyStereotypeAdviceCustomValidator_0;
	public static String ApplyStereotypeAdviceCustomValidator_1;
	public static String ApplyStereotypeAdviceCustomValidator_2;
	public static String ApplyStereotypeAdviceCustomValidator_3;
	public static String ElementTypesCustomValidator_0;
	public static String ElementTypesPluginChecker_0;
	public static String ElementTypesPluginChecker_1;
	public static String ElementTypesPluginXMLValidator_0;
	public static String ElementTypesPluginXMLValidator_1;
	public static String MissingClientContextID_0;
	public static String MissingClientContextID_1;
	public static String MissingElementTypesExtension_0;
	public static String MissingElementTypesExtension_1;
	public static String StereotypeApplicationMatcherCustomValidator_0;
	public static String StereotypeApplicationMatcherCustomValidator_1;
	public static String StereotypePropertyReferenceEdgeAdviceCustomValidator_0;
	public static String StereotypePropertyReferenceEdgeAdviceCustomValidator_1;
	public static String StereotypePropertyReferenceEdgeAdviceCustomValidator_2;
	public static String ValidateElementTypesPluginHandler_0;
	static {
		// initialize resource bundle
		NLS.initializeMessages(BUNDLE_NAME, Messages.class);
	}

	private Messages() {
	}
}
